/*
	fuzzy_ts_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	Fri Dec 15 15:49:34 EST 2000	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "fuzzy_tsn.hh" 	// fuzzy_tsFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *fuzzy_ts_cmd = NULL;
static RCS_STAT_CHANNEL *fuzzy_ts_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// fuzzy_ts
	fuzzy_ts_cmd = new RCS_CMD_CHANNEL(fuzzy_tsFormat, "fuzzy_ts_cmd", "fuzzy_ts_modulesvr", "fuzzy_ts_module.nml");
	if(NULL == fuzzy_ts_cmd)
		return -1;
	if(!fuzzy_ts_cmd->valid())
		return -1;

	fuzzy_ts_stat = new RCS_STAT_CHANNEL(fuzzy_tsFormat, "fuzzy_ts_sts", "fuzzy_ts_modulesvr", "fuzzy_ts_module.nml");
	if(NULL == fuzzy_ts_stat)
		return -1;
	if(!fuzzy_ts_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "fuzzy_ts_modulesvr", "fuzzy_ts_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// fuzzy_ts
	if(NULL != fuzzy_ts_cmd)
	{
		delete fuzzy_ts_cmd;
		fuzzy_ts_cmd = NULL;
	}

	if(NULL != fuzzy_ts_stat)
	{
		delete fuzzy_ts_stat;
		fuzzy_ts_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int fuzzy_ts_modulesvr_run();

int fuzzy_ts_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

